{*************************************************************************}
{ GH Freebrary                                                            }
{                                                                         }
{ GHFCustomPurposeSavePoints.pas - TghCustomPurposeSavePoints class unit. }
{                                                                         }
{ This software is distributed under the open source BSD license.         }
{                                                                         }
{ Copyright (c) 2002-2014, Al Gonzalez (rescatandoadelphi.blogspot.com)   }
{ All rights reserved.                                                    }
{                                                                         }
{ Redistribution and use in source and binary forms, with or without      }
{ modification, are permitted provided that the following conditions are  }
{ met:                                                                    }
{                                                                         }
{   - Redistributions of source code must retain the above copyright      }
{     notice, this list of conditions and the following disclaimer.       }
{   - Redistributions in binary form must reproduce the above copyright   }
{     notice, this list of conditions and the following disclaimer in the }
{     documentation and/or other materials provided with the              }
{     distribution.                                                       }
{   - Neither the name of Al Gonzalez nor the names of his contributors   }
{     may be used to endorse or promote products derived from this        }
{     software without specific prior written permission.                 }
{                                                                         }
{ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS }
{ IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   }
{ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A         }
{ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      }
{ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  }
{ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        }
{ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   }
{ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   }
{ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     }
{ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   }
{ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    }
{*************************************************************************}

{ Please contribute to improve this library.  I am not a good programmer,
  but good programmers know what Delphi is worth.

  A.G. }

Unit GHFCustomPurposeSavePoints;  { Custom Purpose Save Points }

Interface

  Uses
    GHFCustomSavePoint;

  Type
    { Custom Purpose Save Points class }
    TghCustomPurposeSavePoints = Class (TghCustomSavePoints)
      Protected
        { Fields }
        FAfterConfirm :TghCustomSavePointEvent;
        FAfterRestore :TghCustomSavePointEvent;
        FAfterSave :TghCustomSavePointEvent;
        FBeforeConfirm :TghCustomSavePointEvent;
        FBeforeRestore :TghCustomSavePointEvent;
        FBeforeSave :TghCustomSavePointEvent;

        { Overridden methods }
        Procedure DoAfterConfirm (Point :TghCustomSavePoint); Override;
        Procedure DoAfterRestore (Point :TghCustomSavePoint); Override;
        Procedure DoAfterSave (Point :TghCustomSavePoint); Override;
        Procedure DoBeforeConfirm (Point :TghCustomSavePoint); Override;
        Procedure DoBeforeRestore (Point :TghCustomSavePoint); Override;
        Procedure DoBeforeSave (Point :TghCustomSavePoint); Override;
      Published
        { Properties }
        Property AfterConfirm :TghCustomSavePointEvent Read FAfterConfirm
          Write FAfterConfirm;
        Property AfterRestore :TghCustomSavePointEvent Read FAfterRestore
          Write FAfterRestore;
        Property AfterSave :TghCustomSavePointEvent Read FAfterSave
          Write FAfterSave;
        Property BeforeConfirm :TghCustomSavePointEvent Read FBeforeConfirm
          Write FBeforeConfirm;
        Property BeforeRestore :TghCustomSavePointEvent Read FBeforeRestore
          Write FBeforeRestore;
        Property BeforeSave :TghCustomSavePointEvent Read FBeforeSave
          Write FBeforeSave;
    End;

Implementation

  { TghCustomPurposeSavePoints }

  { Protected overridden methods }

  Procedure TghCustomPurposeSavePoints.DoAfterConfirm (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (AfterConfirm) Then
      AfterConfirm (Point);
  End;

  Procedure TghCustomPurposeSavePoints.DoAfterRestore (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (AfterRestore) Then
      AfterRestore (Point);
  End;

  Procedure TghCustomPurposeSavePoints.DoAfterSave (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (AfterSave) Then
      AfterSave (Point);
  End;

  Procedure TghCustomPurposeSavePoints.DoBeforeConfirm (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (BeforeConfirm) Then
      BeforeConfirm (Point);
  End;

  Procedure TghCustomPurposeSavePoints.DoBeforeRestore (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (BeforeRestore) Then
      BeforeRestore (Point);
  End;

  Procedure TghCustomPurposeSavePoints.DoBeforeSave (
    Point :TghCustomSavePoint);
  Begin
    If Assigned (BeforeSave) Then
      BeforeSave (Point);
  End;

End.
