{*************************************************************************}
{ GH Freebrary                                                            }
{                                                                         }
{ GHFMEX.pas - Unit of elements related to Mexico.                        }
{                                                                         }
{ This software is distributed under the open source BSD license.         }
{                                                                         }
{ Copyright (c) 2002-2014, Al Gonzalez (rescatandoadelphi.blogspot.com)   }
{ All rights reserved.                                                    }
{                                                                         }
{ Redistribution and use in source and binary forms, with or without      }
{ modification, are permitted provided that the following conditions are  }
{ met:                                                                    }
{                                                                         }
{   - Redistributions of source code must retain the above copyright      }
{     notice, this list of conditions and the following disclaimer.       }
{   - Redistributions in binary form must reproduce the above copyright   }
{     notice, this list of conditions and the following disclaimer in the }
{     documentation and/or other materials provided with the              }
{     distribution.                                                       }
{   - Neither the name of Al Gonzalez nor the names of his contributors   }
{     may be used to endorse or promote products derived from this        }
{     software without specific prior written permission.                 }
{                                                                         }
{ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS }
{ IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   }
{ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A         }
{ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      }
{ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  }
{ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        }
{ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   }
{ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   }
{ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     }
{ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   }
{ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    }
{*************************************************************************}

{ Please contribute to improve this library.  I am not a good programmer,
  but good programmers know what Delphi is worth.

  A.G. }

Unit GHFMEX;  { Mexico }

Interface

  { Mexico Pesos }
  Function ghMEXPesos (Const Value :Currency) :String;

  { Mexico Pesos Upper case }
  Function ghMEXPesosUpper (Const Value :Currency) :String;

Implementation

  Uses
    GHFES, GHFRTL, SysUtils;

  Function ghMEXPesos (Const Value :Currency) :String;
  Var
    IntPart :Integer;
  Begin
    IntPart := Trunc (Value);
    Result := ghESInLettersQuantity (IntPart);

    If Result = '' Then  // Unsupported value
      Exit;

    Result := Result + ' peso';

    If Abs (IntPart) <> 1 Then
      Result := Result + 's';

    // Cents in numbers and "M.N." suffix
    Result := Result + ' ' + ghStr (Abs (ghFracInt (Value, 2)), 2) +
      '/100 M.N.';
  End;
               
  Function ghMEXPesosUpper (Const Value :Currency) :String;
  Begin
    Result := ANSIUpperCase (ghMEXPesos (Value));
  End;

End.

